#!/usr/bin/env python

from DateSupport import *

d1 = DateTime((2012, 3, 25, 20, 45, 30, "Europe/Oslo"))
d2 = DateTime((2012, 3, 25, 21, 05, 25, "Europe/Oslo"))
ts1 = Timespan(d1, d1)
ts2 = Timespan(d1, d2)

print "d1:", d1, d1.as_ISO8601_datetime_string()
print "d2:", d2, d2.as_ISO8601_datetime_string()

#                              expected         result        operands
print "%r : %r <- %r < %r"  % (d1 < d2,         d1 < d2,      d1, d2)
print "%r : %r <- %r == %r" % (not d1 == d2,    d1 == d2,     d1, d2)
print "%r : %r <- %r < %r"  % (ts1 < ts2,       ts1 < ts2,    ts1, ts2)
print "%r : %r <- %r == %r" % (not ts1 == ts2,  ts1 == ts2,   ts1, ts2)

d2_offset = d2.utc_offset()

#                                     expected             result       operands
print "%r : %r <- %r.utc_offset()" % (d2_offset == (2, 0), d2_offset,   d2)

d3 = DateTime((2012, 3, 25, 21, 05, 25, "America/Montreal"))
d4 = DateTime((2012, 3, 25, 21, 05, 25, "America/Anchorage"))
d5 = DateTime((2012, 3, 25, 21, 05, 25, "America/St_Johns"))
d6 = DateTime((2012, 3, 25, 21, 05, 25, "America/Vancouver"))
d7 = DateTime((2012, 3, 25, 21, 05, 25, "-05:45"))
d8 = DateTime((2012, 3, 25, 21, 05, 25, "05:45"))

#                              expected         result        operands
print "%r : %r <- %r < %r"  % (d2 < d3,         d2 < d3,      d2, d3)
print "%r : %r <- %r < %r"  % (d3 < d4,         d3 < d4,      d3, d4)
print "%r : %r <- %r > %r"  % (d4 > d5,         d4 > d5,      d4, d5)
print "%r : %r <- %r > %r"  % (not d5 > d6,     d5 > d6,      d5, d6)
print "%r : %r <- %r > %r"  % (d6 > d7,         d6 > d7,      d6, d7)
print "%r : %r <- %r > %r"  % (d7 > d8,         d7 > d8,      d7, d8)

d3_offset = d3.utc_offset()
d4_offset = d4.utc_offset()
d5_offset = d5.utc_offset()
d6_offset = d6.utc_offset()
d7_offset = d7.utc_offset()
d8_offset = d8.utc_offset()

#                                     expected                  result       operands
print "%r : %r <- %r.utc_offset()" % (d3_offset == (-4, 0),     d3_offset,   d3)
print "%r : %r <- %r.utc_offset()" % (d4_offset == (-8, 0),     d4_offset,   d4)
print "%r : %r <- %r.utc_offset()" % (d5_offset == (-2, -30),   d5_offset,   d5)
print "%r : %r <- %r.utc_offset()" % (d6_offset == (-7, 0),     d6_offset,   d6)
print "%r : %r <- %r.utc_offset()" % (d7_offset == (-5, -45),   d7_offset,   d7)
print "%r : %r <- %r.utc_offset()" % (d8_offset == (5, 45),     d8_offset,   d8)

#                              expected                 result        operands
print "%r : %r <- %r - %r"  % (d2 - d2 == 0,            d2 - d2,      d2, d2)
print "%r : %r <- %r - %r"  % (d3 - d2 == 6 * 3600,     d3 - d2,      d3, d2)
print "%r : %r <- %r - %r"  % (d4 - d2 == 10 * 3600,    d4 - d2,      d4, d2)
print "%r : %r <- %r - %r"  % (d5 - d2 == 4.5 * 3600,   d5 - d2,      d5, d2)
print "%r : %r <- %r - %r"  % (d6 - d2 == 9 * 3600,     d6 - d2,      d6, d2)
print "%r : %r <- %r - %r"  % (d7 - d2 == 7.75 * 3600,  d7 - d2,      d7, d2)
print "%r : %r <- %r - %r"  % (d8 - d2 == -3.75 * 3600, d8 - d2,      d8, d2)

# vim: tabstop=4 expandtab shiftwidth=4
